<!DOCTYPE html>
<html lang="en">
  <head>
    <title>Classes  Reference</title>
    <link rel="stylesheet" type="text/css" href="css/jazzy.css" />
    <link rel="stylesheet" type="text/css" href="css/highlight.css" />
    <meta charset='utf-8'>
    <script src="js/jquery.min.js" defer></script>
    <script src="js/jazzy.js" defer></script>
    
    <script src="js/lunr.min.js" defer></script>
    <script src="js/typeahead.jquery.js" defer></script>
    <script src="js/jazzy.search.js" defer></script>
  </head>
  <body>
    <a name="//apple_ref/swift/Section/Classes" class="dashAnchor"></a>
    <a title="Classes  Reference"></a>
    <header>
      <div class="content-wrapper">
        <p><a href="index.html">HaishinKit 1.8.0 Docs</a> (88% documented)</p>
        <div class="header-right">
          <form role="search" action="search.json">
            <input type="text" placeholder="Search documentation" data-typeahead>
          </form>
        </div>
      </div>
    </header>
    <div class="content-wrapper">
      <p id="breadcrumbs">
        <a href="index.html">HaishinKit Reference</a>
        <img id="carat" src="img/carat.png" alt=""/>
        Classes  Reference
      </p>
    </div>
    <div class="content-wrapper">
      <nav class="sidebar">
        <ul class="nav-groups">
          <li class="nav-group-name">
            <a href="Classes.html">Classes</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="Classes/ByteArray.html">ByteArray</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/ByteArray/Error.html">– Error</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/Event.html">Event</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/Event/Name.html">– Name</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/EventDispatcher.html">EventDispatcher</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/IOAudioCaptureUnit.html">IOAudioCaptureUnit</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/IOStream.html">IOStream</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/IOStream/ReadyState.html">– ReadyState</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/IOStreamBitRateStrategy.html">IOStreamBitRateStrategy</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/IOStreamRecorder.html">IOStreamRecorder</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/IOStreamRecorder/Error.html">– Error</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/IOStreamVideoAdaptiveBitRateStrategy.html">IOStreamVideoAdaptiveBitRateStrategy</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/IOVideoCaptureUnit.html">IOVideoCaptureUnit</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/InstanceHolder.html">InstanceHolder</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/MTHKView.html">MTHKView</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/NetClient.html">NetClient</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/NetService.html">NetService</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/NetSocket.html">NetSocket</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/PiPHKView.html">PiPHKView</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/PiPHKView.html">PiPHKView</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/RTMPConnection.html">RTMPConnection</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/RTMPConnection/Code.html">– Code</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/RTMPResponder.html">RTMPResponder</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/RTMPSharedObject.html">RTMPSharedObject</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/RTMPStream.html">RTMPStream</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/RTMPStream/Code.html">– Code</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/RTMPStream/HowToPublish.html">– HowToPublish</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/SRTConnection.html">SRTConnection</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/SRTLogger.html">SRTLogger</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/SRTStream.html">SRTStream</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/TSReader.html">TSReader</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/TSWriter.html">TSWriter</a>
              </li>
              <li class="nav-group-task">
                <a href="Classes/VideoEffect.html">VideoEffect</a>
              </li>
            </ul>
          </li>
          <li class="nav-group-name">
            <a href="Global%20Variables.html">Global Variables</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="Global%20Variables.html#/s:10HaishinKit12kASUndefinedAA0C0Vvp">kASUndefined</a>
              </li>
            </ul>
          </li>
          <li class="nav-group-name">
            <a href="Enums.html">Enumerations</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="Enums/DeviceUtil.html">DeviceUtil</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/DeviceUtil.html">DeviceUtil</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/FeatureUtil.html">FeatureUtil</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/FeatureUtil/Name.html">– Name</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/IOAudioMixerError.html">IOAudioMixerError</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/IOAudioUnitError.html">IOAudioUnitError</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/IOVideoUnitError.html">IOVideoUnitError</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/ImageTransform.html">ImageTransform</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/RTMPObjectEncoding.html">RTMPObjectEncoding</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/SRTLogFunctionalArea.html">SRTLogFunctionalArea</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/SRTLogLevel.html">SRTLogLevel</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/SRTMode.html">SRTMode</a>
              </li>
              <li class="nav-group-task">
                <a href="Enums/SRTSocketOption.html">SRTSocketOption</a>
              </li>
            </ul>
          </li>
          <li class="nav-group-name">
            <a href="Extensions.html">Extensions</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="Extensions.html#/s:13SRTHaishinKit9SRTSocketC">SRTSocket</a>
              </li>
            </ul>
          </li>
          <li class="nav-group-name">
            <a href="Protocols.html">Protocols</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="Protocols/EventDispatcherConvertible.html">EventDispatcherConvertible</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/IOMuxer.html">IOMuxer</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/IOStreamBitRateStrategyConvertible.html">IOStreamBitRateStrategyConvertible</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/IOStreamDelegate.html">IOStreamDelegate</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/IOStreamObserver.html">IOStreamObserver</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/IOStreamRecorderDelegate.html">IOStreamRecorderDelegate</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/IOStreamView.html">IOStreamView</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/RTMPConnectionDelegate.html">RTMPConnectionDelegate</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/Running.html">Running</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/TSReaderDelegate.html">TSReaderDelegate</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols/TSWriterDelegate.html">TSWriterDelegate</a>
              </li>
            </ul>
          </li>
          <li class="nav-group-name">
            <a href="Structs.html">Structures</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="Structs/ASArray.html">ASArray</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/ASTypedObject.html">ASTypedObject</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/ASUndefined.html">ASUndefined</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/ASXML.html">ASXML</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/ASXMLDocument.html">ASXMLDocument</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/Atomic.html">Atomic</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/AudioCodecSettings.html">AudioCodecSettings</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/IOAudioMixerSettings.html">IOAudioMixerSettings</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/IOAudioMixerTrackSettings.html">IOAudioMixerTrackSettings</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/IOStreamBitRateStats.html">IOStreamBitRateStats</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/IOVideoMixerSettings.html">IOVideoMixerSettings</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/IOVideoMixerSettings/Mode.html">– Mode</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/RTMPStreamInfo.html">RTMPStreamInfo</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/SRTPerformanceData.html">SRTPerformanceData</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/SoundTransform.html">SoundTransform</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/VTSessionOption.html">VTSessionOption</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/VideoCodecSettings.html">VideoCodecSettings</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/VideoCodecSettings/BitRateMode.html">– BitRateMode</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/VideoCodecSettings/ScalingMode.html">– ScalingMode</a>
              </li>
            </ul>
          </li>
          <li class="nav-group-name">
            <a href="Typealiases.html">Type Aliases</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="Typealiases.html#/s:10HaishinKit8ASObjecta">ASObject</a>
              </li>
              <li class="nav-group-task">
                <a href="Typealiases.html#/s:10HaishinKit32IOAudioCaptureConfigurationBlocka">IOAudioCaptureConfigurationBlock</a>
              </li>
              <li class="nav-group-task">
                <a href="Typealiases.html#/s:10HaishinKit32IOVideoCaptureConfigurationBlocka">IOVideoCaptureConfigurationBlock</a>
              </li>
            </ul>
          </li>
        </ul>
      </nav>
      <article class="main-content">
        <section>
          <section class="section">
            <h1>Classes</h1>
            <p>The following classes are available globally.</p>

          </section>
          <section class="section task-group-section">
            <div class="task-group">
              <ul>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:10HaishinKit18IOAudioCaptureUnitC"></a>
                    <a name="//apple_ref/swift/Class/IOAudioCaptureUnit" class="dashAnchor"></a>
                    <a class="token" href="#/s:10HaishinKit18IOAudioCaptureUnitC">IOAudioCaptureUnit</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>An object that provides the interface to control the AVCaptureDevice&rsquo;s transport behavior.</p>

                        <a href="Classes/IOAudioCaptureUnit.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">@available(tvOS 17.0, *)</span>
<span class="kd">public</span> <span class="kd">final</span> <span class="kd">class</span> <span class="kt">IOAudioCaptureUnit</span> <span class="p">:</span> <span class="kt">IOCaptureUnit</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/c:@M@HaishinKit@objc(cs)IOStream"></a>
                    <a name="//apple_ref/swift/Class/IOStream" class="dashAnchor"></a>
                    <a class="token" href="#/c:@M@HaishinKit@objc(cs)IOStream">IOStream</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>The <code>IOStream</code> class is the foundation of a RTMPStream.</p>

                        <a href="Classes/IOStream.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">open</span> <span class="kd">class</span> <span class="kt">IOStream</span> <span class="p">:</span> <span class="kt">NSObject</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:10HaishinKit23IOStreamBitRateStrategyC"></a>
                    <a name="//apple_ref/swift/Class/IOStreamBitRateStrategy" class="dashAnchor"></a>
                    <a class="token" href="#/s:10HaishinKit23IOStreamBitRateStrategyC">IOStreamBitRateStrategy</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>The IOStreamBitRateStrategy class provides a no operative bitrate storategy.</p>

                        <a href="Classes/IOStreamBitRateStrategy.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">public</span> <span class="kd">final</span> <span class="kd">class</span> <span class="kt">IOStreamBitRateStrategy</span> <span class="p">:</span> <span class="kt"><a href="Protocols/IOStreamBitRateStrategyConvertible.html">IOStreamBitRateStrategyConvertible</a></span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:10HaishinKit36IOStreamVideoAdaptiveBitRateStrategyC"></a>
                    <a name="//apple_ref/swift/Class/IOStreamVideoAdaptiveBitRateStrategy" class="dashAnchor"></a>
                    <a class="token" href="#/s:10HaishinKit36IOStreamVideoAdaptiveBitRateStrategyC">IOStreamVideoAdaptiveBitRateStrategy</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>The IOStreamVideoAdaptiveBitRateStrategy class provides an algorithm that focuses on video bitrate control.</p>

                        <a href="Classes/IOStreamVideoAdaptiveBitRateStrategy.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">public</span> <span class="kd">final</span> <span class="kd">class</span> <span class="kt">IOStreamVideoAdaptiveBitRateStrategy</span> <span class="p">:</span> <span class="kt"><a href="Protocols/IOStreamBitRateStrategyConvertible.html">IOStreamBitRateStrategyConvertible</a></span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:10HaishinKit16IOStreamRecorderC"></a>
                    <a name="//apple_ref/swift/Class/IOStreamRecorder" class="dashAnchor"></a>
                    <a class="token" href="#/s:10HaishinKit16IOStreamRecorderC">IOStreamRecorder</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>The IOStreamRecorder class represents video and audio recorder.</p>

                        <a href="Classes/IOStreamRecorder.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">public</span> <span class="kd">final</span> <span class="kd">class</span> <span class="kt">IOStreamRecorder</span></code></pre>
<pre class="highlight swift"><code><span class="kd">extension</span> <span class="kt">IOStreamRecorder</span><span class="p">:</span> <span class="kt"><a href="Protocols/IOStreamObserver.html">IOStreamObserver</a></span></code></pre>
<pre class="highlight swift"><code><span class="kd">extension</span> <span class="kt">IOStreamRecorder</span><span class="p">:</span> <span class="kt"><a href="Protocols/Running.html">Running</a></span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:10HaishinKit18IOVideoCaptureUnitC"></a>
                    <a name="//apple_ref/swift/Class/IOVideoCaptureUnit" class="dashAnchor"></a>
                    <a class="token" href="#/s:10HaishinKit18IOVideoCaptureUnitC">IOVideoCaptureUnit</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>An object that provides the interface to control the AVCaptureDevice&rsquo;s transport behavior.</p>

                        <a href="Classes/IOVideoCaptureUnit.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">@available(tvOS 17.0, *)</span>
<span class="kd">public</span> <span class="kd">final</span> <span class="kd">class</span> <span class="kt">IOVideoCaptureUnit</span> <span class="p">:</span> <span class="kt">IOCaptureUnit</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/c:@M@HaishinKit@objc(cs)MTHKView"></a>
                    <a name="//apple_ref/swift/Class/MTHKView" class="dashAnchor"></a>
                    <a class="token" href="#/c:@M@HaishinKit@objc(cs)MTHKView">MTHKView</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>A view that displays a video content of a NetStream object which uses Metal api.</p>

                        <a href="Classes/MTHKView.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">public</span> <span class="kd">class</span> <span class="kt">MTHKView</span> <span class="p">:</span> <span class="kt">MTKView</span></code></pre>
<pre class="highlight swift"><code><span class="kd">extension</span> <span class="kt">MTHKView</span><span class="p">:</span> <span class="kt"><a href="Protocols/IOStreamView.html">IOStreamView</a></span></code></pre>
<pre class="highlight swift"><code><span class="kd">extension</span> <span class="kt">MTHKView</span><span class="p">:</span> <span class="kt">MTKViewDelegate</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/"></a>
                    <a name="//apple_ref/swift/Class/PiPHKView" class="dashAnchor"></a>
                    <a class="token" href="#/">PiPHKView</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>A view that displays a video content of a NetStream object which uses AVSampleBufferDisplayLayer api.</p>

                        <a href="Classes/PiPHKView.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          
                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/c:@M@HaishinKit@objc(cs)PiPHKView"></a>
                    <a name="//apple_ref/swift/Class/PiPHKView" class="dashAnchor"></a>
                    <a class="token" href="#/c:@M@HaishinKit@objc(cs)PiPHKView">PiPHKView</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>A view that displays a video content of a NetStream object which uses AVSampleBufferDisplayLayer api.</p>

                        <a href="Classes/PiPHKView.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">public</span> <span class="kd">class</span> <span class="kt">PiPHKView</span> <span class="p">:</span> <span class="kt">NSView</span></code></pre>
<pre class="highlight swift"><code><span class="kd">extension</span> <span class="kt">PiPHKView</span><span class="p">:</span> <span class="kt"><a href="Protocols/IOStreamView.html">IOStreamView</a></span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/c:@M@HaishinKit@objc(cs)VideoEffect"></a>
                    <a name="//apple_ref/swift/Class/VideoEffect" class="dashAnchor"></a>
                    <a class="token" href="#/c:@M@HaishinKit@objc(cs)VideoEffect">VideoEffect</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>An object that apply a video effect.</p>
<div class="aside aside-seealso">
    <p class="aside-title">Seealso</p>
    <a href="https://developer.apple.com/documentation/coreimage/processing_an_image_using_built-in_filters">https://developer.apple.com/documentation/coreimage/processing_an_image_using_built-in_filters</a>

</div>
<h2 id='example-code' class='heading'>Example code:</h2>
<pre class="highlight swift"><code><span class="kd">final</span> <span class="kd">class</span> <span class="kt">MonochromeEffect</span><span class="p">:</span> <span class="kt">VideoEffect</span> <span class="p">{</span>
    <span class="k">let</span> <span class="nv">filter</span><span class="p">:</span> <span class="kt">CIFilter</span><span class="p">?</span> <span class="o">=</span> <span class="kt">CIFilter</span><span class="p">(</span><span class="nv">name</span><span class="p">:</span> <span class="s">"CIColorMonochrome"</span><span class="p">)</span>

    <span class="k">override</span> <span class="kd">func</span> <span class="nf">execute</span><span class="p">(</span><span class="n">_</span> <span class="nv">image</span><span class="p">:</span> <span class="kt">CIImage</span><span class="p">,</span> <span class="nv">info</span><span class="p">:</span> <span class="kt">CMSampleBuffer</span><span class="p">?)</span> <span class="o">-&gt;</span> <span class="kt">CIImage</span> <span class="p">{</span>
        <span class="k">guard</span> <span class="k">let</span> <span class="nv">filter</span><span class="p">:</span> <span class="kt">CIFilter</span> <span class="o">=</span> <span class="n">filter</span> <span class="k">else</span> <span class="p">{</span>
            <span class="k">return</span> <span class="n">image</span>
        <span class="p">}</span>
        <span class="n">filter</span><span class="o">.</span><span class="nf">setValue</span><span class="p">(</span><span class="n">image</span><span class="p">,</span> <span class="nv">forKey</span><span class="p">:</span> <span class="s">"inputImage"</span><span class="p">)</span>
        <span class="n">filter</span><span class="o">.</span><span class="nf">setValue</span><span class="p">(</span><span class="kt">CIColor</span><span class="p">(</span><span class="nv">red</span><span class="p">:</span> <span class="mf">0.75</span><span class="p">,</span> <span class="nv">green</span><span class="p">:</span> <span class="mf">0.75</span><span class="p">,</span> <span class="nv">blue</span><span class="p">:</span> <span class="mf">0.75</span><span class="p">),</span> <span class="nv">forKey</span><span class="p">:</span> <span class="s">"inputColor"</span><span class="p">)</span>
        <span class="n">filter</span><span class="o">.</span><span class="nf">setValue</span><span class="p">(</span><span class="mf">1.0</span><span class="p">,</span> <span class="nv">forKey</span><span class="p">:</span> <span class="s">"inputIntensity"</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">filter</span><span class="o">.</span><span class="n">outputImage</span> <span class="p">??</span> <span class="n">image</span>
    <span class="p">}</span>
<span class="p">}</span>
</code></pre>

                        <a href="Classes/VideoEffect.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">open</span> <span class="kd">class</span> <span class="kt">VideoEffect</span> <span class="p">:</span> <span class="kt">NSObject</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:10HaishinKit8TSReaderC"></a>
                    <a name="//apple_ref/swift/Class/TSReader" class="dashAnchor"></a>
                    <a class="token" href="#/s:10HaishinKit8TSReaderC">TSReader</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>The TSReader class represents read MPEG-2 transport stream data.</p>

                        <a href="Classes/TSReader.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">public</span> <span class="kd">class</span> <span class="kt">TSReader</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:10HaishinKit8TSWriterC"></a>
                    <a name="//apple_ref/swift/Class/TSWriter" class="dashAnchor"></a>
                    <a class="token" href="#/s:10HaishinKit8TSWriterC">TSWriter</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>The TSWriter class represents writes MPEG-2 transport stream data.</p>

                        <a href="Classes/TSWriter.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">public</span> <span class="kd">final</span> <span class="kd">class</span> <span class="kt">TSWriter</span></code></pre>
<pre class="highlight swift"><code><span class="kd">extension</span> <span class="kt">TSWriter</span><span class="p">:</span> <span class="kt"><a href="Protocols/IOMuxer.html">IOMuxer</a></span></code></pre>
<pre class="highlight swift"><code><span class="kd">extension</span> <span class="kt">TSWriter</span><span class="p">:</span> <span class="kt"><a href="Protocols/Running.html">Running</a></span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/c:@M@HaishinKit@objc(cs)NetClient"></a>
                    <a name="//apple_ref/swift/Class/NetClient" class="dashAnchor"></a>
                    <a class="token" href="#/c:@M@HaishinKit@objc(cs)NetClient">NetClient</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>The NetClient class creates a two-way connection  between a NetService.</p>

                        <a href="Classes/NetClient.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">public</span> <span class="kd">final</span> <span class="kd">class</span> <span class="kt">NetClient</span> <span class="p">:</span> <span class="kt"><a href="Classes/NetSocket.html">NetSocket</a></span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/c:@M@HaishinKit@objc(cs)NetService"></a>
                    <a name="//apple_ref/swift/Class/NetService" class="dashAnchor"></a>
                    <a class="token" href="#/c:@M@HaishinKit@objc(cs)NetService">NetService</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>The NetService class creates a two-way connection between a client and a server as a server.</p>

                        <a href="Classes/NetService.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">open</span> <span class="kd">class</span> <span class="kt">NetService</span> <span class="p">:</span> <span class="kt">NSObject</span></code></pre>
<pre class="highlight swift"><code><span class="kd">extension</span> <span class="kt">NetService</span><span class="p">:</span> <span class="kt">NetServiceDelegate</span></code></pre>
<pre class="highlight swift"><code><span class="kd">extension</span> <span class="kt">NetService</span><span class="p">:</span> <span class="kt"><a href="Protocols/Running.html">Running</a></span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/c:@M@HaishinKit@objc(cs)NetSocket"></a>
                    <a name="//apple_ref/swift/Class/NetSocket" class="dashAnchor"></a>
                    <a class="token" href="#/c:@M@HaishinKit@objc(cs)NetSocket">NetSocket</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>The NetSocket class creates a two-way connection between a client and a server as a client. This class is wrapper for a InputStream and an OutputStream.</p>

                        <a href="Classes/NetSocket.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">open</span> <span class="kd">class</span> <span class="kt">NetSocket</span> <span class="p">:</span> <span class="kt">NSObject</span></code></pre>
<pre class="highlight swift"><code><span class="kd">extension</span> <span class="kt">NetSocket</span><span class="p">:</span> <span class="kt">StreamDelegate</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:10HaishinKit5EventC"></a>
                    <a name="//apple_ref/swift/Class/Event" class="dashAnchor"></a>
                    <a class="token" href="#/s:10HaishinKit5EventC">Event</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>The Event interface is used to provide information.</p>

                        <a href="Classes/Event.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">public</span> <span class="kd">final</span> <span class="kd">class</span> <span class="kt">Event</span></code></pre>
<pre class="highlight swift"><code><span class="kd">extension</span> <span class="kt">Event</span><span class="p">:</span> <span class="kt">CustomDebugStringConvertible</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:10HaishinKit15EventDispatcherC"></a>
                    <a name="//apple_ref/swift/Class/EventDispatcher" class="dashAnchor"></a>
                    <a class="token" href="#/s:10HaishinKit15EventDispatcherC">EventDispatcher</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>The EventDispatcher interface is in implementation which supports the DOM Event Model.</p>

                        <a href="Classes/EventDispatcher.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">public</span> <span class="kd">class</span> <span class="kt">EventDispatcher</span> <span class="p">:</span> <span class="kt"><a href="Protocols/EventDispatcherConvertible.html">EventDispatcherConvertible</a></span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:10HaishinKit13RTMPResponderC"></a>
                    <a name="//apple_ref/swift/Class/RTMPResponder" class="dashAnchor"></a>
                    <a class="token" href="#/s:10HaishinKit13RTMPResponderC">RTMPResponder</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>The RTMPResponder class provides to use handle RTMPConnection&rsquo;s callback.</p>

                        <a href="Classes/RTMPResponder.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">open</span> <span class="kd">class</span> <span class="kt">RTMPResponder</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:10HaishinKit14RTMPConnectionC"></a>
                    <a name="//apple_ref/swift/Class/RTMPConnection" class="dashAnchor"></a>
                    <a class="token" href="#/s:10HaishinKit14RTMPConnectionC">RTMPConnection</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>The RTMPConneciton class create a two-way RTMP connection.</p>

                        <a href="Classes/RTMPConnection.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">public</span> <span class="kd">class</span> <span class="kt">RTMPConnection</span> <span class="p">:</span> <span class="kt"><a href="Classes/EventDispatcher.html">EventDispatcher</a></span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:10HaishinKit16RTMPSharedObjectC"></a>
                    <a name="//apple_ref/swift/Class/RTMPSharedObject" class="dashAnchor"></a>
                    <a class="token" href="#/s:10HaishinKit16RTMPSharedObjectC">RTMPSharedObject</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>The RTMPSharedObject class is used to read and write data on a server.</p>

                        <a href="Classes/RTMPSharedObject.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">public</span> <span class="kd">final</span> <span class="kd">class</span> <span class="kt">RTMPSharedObject</span> <span class="p">:</span> <span class="kt"><a href="Classes/EventDispatcher.html">EventDispatcher</a></span></code></pre>
<pre class="highlight swift"><code><span class="kd">extension</span> <span class="kt">RTMPSharedObject</span><span class="p">:</span> <span class="kt">CustomDebugStringConvertible</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/c:@M@HaishinKit@objc(cs)RTMPStream"></a>
                    <a name="//apple_ref/swift/Class/RTMPStream" class="dashAnchor"></a>
                    <a class="token" href="#/c:@M@HaishinKit@objc(cs)RTMPStream">RTMPStream</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>An object that provides the interface to control a one-way channel over a RtmpConnection.</p>

                        <a href="Classes/RTMPStream.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">open</span> <span class="kd">class</span> <span class="kt">RTMPStream</span> <span class="p">:</span> <span class="kt"><a href="Classes/IOStream.html">IOStream</a></span></code></pre>
<pre class="highlight swift"><code><span class="kd">extension</span> <span class="kt">RTMPStream</span><span class="p">:</span> <span class="kt"><a href="Protocols/EventDispatcherConvertible.html">EventDispatcherConvertible</a></span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:10HaishinKit9ByteArrayC"></a>
                    <a name="//apple_ref/swift/Class/ByteArray" class="dashAnchor"></a>
                    <a class="token" href="#/s:10HaishinKit9ByteArrayC">ByteArray</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>The ByteArray class provides methods and properties the reading or writing with binary data.</p>

                        <a href="Classes/ByteArray.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">public</span> <span class="kd">class</span> <span class="kt">ByteArray</span> <span class="p">:</span> <span class="kt">ByteArrayConvertible</span></code></pre>
<pre class="highlight swift"><code><span class="kd">extension</span> <span class="kt">ByteArray</span><span class="p">:</span> <span class="kt">CustomDebugStringConvertible</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:10HaishinKit14InstanceHolderC"></a>
                    <a name="//apple_ref/swift/Class/InstanceHolder" class="dashAnchor"></a>
                    <a class="token" href="#/s:10HaishinKit14InstanceHolderC">InstanceHolder</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>The InstanceHolder class provides a shared instance memory management.</p>

                        <a href="Classes/InstanceHolder.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">public</span> <span class="kd">class</span> <span class="kt">InstanceHolder</span><span class="o">&lt;</span><span class="kt">T</span><span class="o">&gt;</span> <span class="k">where</span> <span class="kt">T</span> <span class="p">:</span> <span class="kt">Equatable</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/c:@M@SRTHaishinKit@objc(cs)SRTConnection"></a>
                    <a name="//apple_ref/swift/Class/SRTConnection" class="dashAnchor"></a>
                    <a class="token" href="#/c:@M@SRTHaishinKit@objc(cs)SRTConnection">SRTConnection</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>The SRTConnection class create a two-way SRT connection.</p>

                        <a href="Classes/SRTConnection.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">public</span> <span class="kd">final</span> <span class="kd">class</span> <span class="kt">SRTConnection</span> <span class="p">:</span> <span class="kt">NSObject</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:13SRTHaishinKit9SRTLoggerC"></a>
                    <a name="//apple_ref/swift/Class/SRTLogger" class="dashAnchor"></a>
                    <a class="token" href="#/s:13SRTHaishinKit9SRTLoggerC">SRTLogger</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>An object for writing interpolated string messages to srt logging system.</p>

                        <a href="Classes/SRTLogger.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">public</span> <span class="kd">class</span> <span class="kt">SRTLogger</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/c:@M@SRTHaishinKit@objc(cs)SRTStream"></a>
                    <a name="//apple_ref/swift/Class/SRTStream" class="dashAnchor"></a>
                    <a class="token" href="#/c:@M@SRTHaishinKit@objc(cs)SRTStream">SRTStream</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>An object that provides the interface to control a one-way channel over a SRTConnection.</p>

                        <a href="Classes/SRTStream.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">public</span> <span class="kd">final</span> <span class="kd">class</span> <span class="kt">SRTStream</span> <span class="p">:</span> <span class="kt"><a href="Classes/IOStream.html">IOStream</a></span></code></pre>
<pre class="highlight swift"><code><span class="kd">extension</span> <span class="kt">SRTStream</span><span class="p">:</span> <span class="kt"><a href="Protocols/TSWriterDelegate.html">TSWriterDelegate</a></span></code></pre>
<pre class="highlight swift"><code><span class="kd">extension</span> <span class="kt">SRTStream</span><span class="p">:</span> <span class="kt"><a href="Protocols/TSReaderDelegate.html">TSReaderDelegate</a></span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
              </ul>
            </div>
          </section>
        </section>
        <section id="footer">
          <p>&copy; 2024 <a class="link" href="https://github.com/shogo4405/HaishinKit.swift" target="_blank" rel="external noopener">shogo4405</a>. All rights reserved. (Last updated: 2024-04-22)</p>
          <p>Generated by <a class="link" href="https://github.com/realm/jazzy" target="_blank" rel="external noopener">jazzy ♪♫ v0.14.4</a>, a <a class="link" href="https://realm.io" target="_blank" rel="external noopener">Realm</a> project.</p>
        </section>
      </article>
    </div>
  </body>
</html>
